import c4d
from c4d import gui
 
# Unique id numbers for each of the GUI elements:
LBL_USAGE = 1000
GROUP_OPTIONS = 30000
BTN_OK = 30001
BTN_CANCEL = 30002

class OptionsDialog(gui.GeDialog):

  def CreateLayout(self):
    self.SetTitle('Folding Title GENERATOR - Alert!')
    self.AddMultiLineEditText(LBL_USAGE, c4d.BFV_SCALEFIT, inith=40, initw=580,
                              style=c4d.DR_MULTILINE_READONLY)
    self.SetString(LBL_USAGE, '  Element already added!\n' +'  ---\n' +'  USAGE: You cannot add the same element twice,\n' +'                To replace the existing item, please press "Replace"')
    # Buttons - an Ok and Cancel button:
    self.GroupBegin(GROUP_OPTIONS, c4d.BFH_CENTER, 2, 1)
    self.AddButton(BTN_OK, c4d.BFH_SCALE, name='Replace')
    self.AddButton(BTN_CANCEL, c4d.BFH_SCALE, name='Cancel')
    self.GroupEnd()
    self.ok = False
    return True
 
  # React to user's input:
  def Command(self, id, msg):
    if id==BTN_CANCEL:
      self.Close()
    elif id==BTN_OK:
      mat1 = doc.SearchMaterial("HDRI")
      mat2 = doc.SearchMaterial("Floor")
      if mat1 != None:
          mat1.Remove()      
      if mat2 != None:
          mat2.Remove()
      doc.SearchObject("Mini-Studio").Remove()
      root = 'preset://foldingtitlegenerator1.0.lib4d/Mini-Studio'
      c4d.documents.MergeDocument(doc, root, c4d.SCENEFILTER_MATERIALS | c4d.SCENEFILTER_OBJECTS)
      self.ok = True
      self.Close()
    return True
 
def main():

  # Open the options dialogue to let users choose their options.
  if doc.SearchObject("Mini-Studio") == None :      
      mat1 = doc.SearchMaterial("HDRI")
      mat2 = doc.SearchMaterial("Floor")  
      if mat1 != None:
          mat1.Remove()      
      if mat2 != None:
          mat2.Remove() 
      root = 'preset://foldingtitlegenerator1.0.lib4d/Mini-Studio'
      c4d.documents.MergeDocument(doc, root, c4d.SCENEFILTER_MATERIALS | c4d.SCENEFILTER_OBJECTS)   
  else :
      dlg = OptionsDialog()
      dlg.Open(c4d.DLG_TYPE_MODAL, defaultw=300, defaulth=140)
      if not dlg.ok:
          return

  c4d.EventAdd()  # Update C4D to see changes.
 
if __name__=='__main__':
  main()